/**
 * Introduction
 *
 * @title ROV - Easy applications from C
 *
 * @copyright Jason Tribbeck / 7th ARM 1994-2001
 *
 * @authors Jason Tribbeck
 *
 * @file ro35error.c
 */

#include <stdio.h>
#include <string.h>
#include <stdarg.h>

#include "kernel.h"

#include "main.h"

int ro35error_errorbox(char * buttons, int mode, char * sprname, char * string, ...)
{
  _kernel_oserror o;
  char title[48];
  va_list valist;
  _kernel_swi_regs regs;

  va_start(valist, string);
  o.errnum = 0;
  vsprintf(o.errmess, string, valist);
  va_end(valist);

  regs.r[0] = (int) & o;
  regs.r[1] = 16 | 256 | (mode << 9);
  regs.r[2] = (int)title;
  regs.r[3] = (int)sprname;
  regs.r[4] = 1;
  regs.r[5] = (int)buttons;
  strcpy(title, TASKNAME);
  _kernel_swi(0x600df, & regs, & regs);
  return regs.r[1];
}
